' Changeable Settings
Global MazeSize=128
Global ShowGenerating=20	' 0 for instant, 1 for show every step, 10 for show every 10 steps, etc..
Global Straightness=0		' 0 for squiggly, higher for longer straight paths.


' Probably changeable if you want..
Global jscrw=800
Global jscrh=800


' Not really all that changeable..
Global grid[1024*1024]
Global stackX[1024*1024]
Global stackY[1024*1024]
Global stackD$[1024*1024]
Global map[4]
Global stackTo=0
Global LastD$=""
Global countD=0

' For the Solver
Global solveVal[1024*1024]
Global solveShow[1024*1024]
Global p1x,p2x,p1y,p2y
Global click=0




Graphics jscrw,jscrh,0

GenerateMaze()
Repeat
	DrawMaze(1)
	
	If KeyDown(KEY_R) Then MazeSize=Rand(16,128);Straightness=Rand(0,8);GenerateMaze()
	If KeyDown(KEY_SPACE) Then GenerateMaze()
	
Until KeyDown(KEY_ESCAPE)




Function DrawMaze(green=0)
Cls
	gap=jscrw/MazeSize
	mx=MouseX()/gap
	my=MouseY()/gap
	mh=MouseHit(1)
	
	If mh=1 And green=1 And click=0 And grid[my*MazeSize+mx]=1 Then p1x=mx;p1y=my;click=1;mh=0;SolveMaze()
	If mh=1 And green=1 And click=1 And grid[my*MazeSize+mx]=1 Then p2x=mx;p2y=my;click=0;mh=0;SolveMaze()

	
	
	For x=0 To MazeSize-1
	For y=0 To MazeSize-1
		If grid[y*MazeSize+x]=1
			SetColor 255,255,255
			If green=1 Then SetColor 180,200,255
			If solveShow[y*MazeSize+x]=1 Then SetColor 255,80,50
			DrawRect(x*gap,y*gap,gap,gap)
		EndIf
		
	Next
	Next
	Delay 5
Flip
End Function

' Generating the Maze
Function GenerateMaze()
SeedRnd MilliSecs();For n=0 To 100;r=Rnd(100);Next

If Floor(Float(MazeSize)/2.0)=Float(MazeSize)/2.0 Then MazeSize=MazeSize+1
	
	' Start.. Reset Everything
	stackTo=0
	click=0
	countD=37171650
	For x=0 To MazeSize-1
	For y=0 To MazeSize-1
		grid[y*MazeSize+x]=0
		solveVal[y*MazeSize+x]=0
		solveShow[y*MazeSize+x]=0
	Next
	Next

	' Pick a random X/Y point	
	x=(Rand(0,Floor(MazeSize/2))*2)+1
	y=(Rand(0,Floor(MazeSize/2))*2)+1
	p1x=MazeSize-2;p1y=MazeSize-2
	p2x=1;p2y=1
	grid[y*MazeSize+x]=1
		' Record the point, and store it in the stack
		stackTo=stackTo+1;stackX[stackTo]=x;stackY[stackTo]=y;stackD$[stackTo]=GetDir$()	' This stores the position in the stack, and fetches a new set of random directions.
	draw=0
	
	
	
	Repeat
		fin=0
		If stackD$[stackTo]<>""
			' Go through all four directions listed from the GetDir
			d=Int(Mid$(stackD$[stackTo],1,1))
			stackD$[stackTo]=Right$(stackD$[stackTo],Len(stackD$[stackTo])-1)
			

			did=0
			' If it finds an available place to move, it stores the previous location in the stack, moves to the next point, and cycles through the next four directions for that point.
			If d=0 And y>=2
				If grid[((y-2)*MazeSize)+x]=0	' Go up
					did=1;y=y-1;grid[((y)*MazeSize)+x]=1;y=y-1;grid[((y)*MazeSize)+x]=1;
					stackTo=stackTo+1;stackX[stackTo]=x;stackY[stackTo]=y;stackD$[stackTo]=GetDir$();draw=draw+1
				EndIf
			EndIf
			If d=1 And x<=MazeSize-3
				If grid[((y)*MazeSize)+(x+2)]=0	' Right
					did=1;x=x+1;grid[((y)*MazeSize)+x]=1;x=x+1;grid[((y)*MazeSize)+x]=1;
					stackTo=stackTo+1;stackX[stackTo]=x;stackY[stackTo]=y;stackD$[stackTo]=GetDir$();draw=draw+1
				EndIf
			EndIf
			If d=2 And y<=MazeSize-3
				If grid[((y+2)*MazeSize)+x]=0	' Down
					did=1;y=y+1;grid[((y)*MazeSize)+x]=1;y=y+1;grid[((y)*MazeSize)+x]=1;
					stackTo=stackTo+1;stackX[stackTo]=x;stackY[stackTo]=y;stackD$[stackTo]=GetDir$();draw=draw+1
				EndIf
			EndIf
			If d=3 And x>=2
				If grid[((y)*MazeSize)+(x-2)]=0	' Left
					did=1;x=x-1;grid[((y)*MazeSize)+x]=1;x=x-1;grid[((y)*MazeSize)+x]=1;
					stackTo=stackTo+1;stackX[stackTo]=x;stackY[stackTo]=y;stackD$[stackTo]=GetDir$();draw=draw+1
				EndIf
			EndIf
		EndIf
		

		
		If stackD$[stackto]=""
			' Once all four possibilities have been tested, it moves back to the previous point in the stack.
			stackTo=stackTo-1
			If stackTo>0 Then x=stackX[stackTo];y=stackY[stackTo]
			If stackTo=0 Then fin=1
		EndIf
		
		If draw>ShowGenerating And ShowGenerating>0 Then DrawMaze;draw=0
		If KeyDown(KEY_ESCAPE) Then End
	Until fin=1
	
	SolveMaze()
	' And .. pretty much.. that's it..
End Function

Function GetDir$()
	' returns a string of 4 numbers (0,1,2,3) in a random order, so that each point has a random 4 directions to flick through
	
	countD=countD+1
	If countD<Straightness Then Return LastD$
	
	countD=0

	For n=0 To 3
		map[n]=n
	Next
	For n=0 To 3
		r=Rand(0,3)
		t=map[n]
		map[n]=map[r]
		map[r]=t
	Next
	LastD$=Chr$(map[0]+48)+Chr$(map[1]+48)+Chr$(map[2]+48)+Chr$(map[3]+48)
	Return LastD
End Function



' Solving the Maze
Function SolveMaze()
home=0
For x=0 To MazeSize-1
For y=0 To MazeSize-1
solveVal[y*MazeSize+x]=0
solveShow[y*MazeSize+x]=0
Next
Next
solveVal[p1y*MazeSize+p1x]=1


For n=2 To MazeSize*MazeSize
	For x=0 To MazeSize-1
	For y=0 To MazeSize-1
		If grid[y*MazeSize+x]=1 And solveVal[y*MazeSize+x]=0
			If solveVal[((y)*MazeSize)+(x+1)]=n-1 Then solveVal[y*MazeSize+x]=n
			If solveVal[((y)*MazeSize)+(x-1)]=n-1 Then solveVal[y*MazeSize+x]=n
			If solveVal[((y+1)*MazeSize)+(x)]=n-1 Then solveVal[y*MazeSize+x]=n
			If solveVal[((y-1)*MazeSize)+(x)]=n-1 Then solveVal[y*MazeSize+x]=n
			
			If solveVal[y*MazeSize+x]=n And x=p2x And y=p2y Then home=1
		EndIf
	Next
	Next
If home=1 Then m=n;n=MazeSize*MazeSize+1
Next

x=p2x;y=p2y
Repeat
	solveShow[y*MazeSize+x]=1
	If solveVal[((y)*MazeSize)+(x+1)]=m-1 Then x=x+1
	If solveVal[((y)*MazeSize)+(x-1)]=m-1 Then x=x-1
	If solveVal[((y+1)*MazeSize)+(x)]=m-1 Then y=y+1
	If solveVal[((y-1)*MazeSize)+(x)]=m-1 Then y=y-1
	m=m-1
Until m=0
solveShow[y*MazeSize+x]=1
End Function